//cl /ZI  GDBserverClient.c  ws2_32.lib


#if defined(LINUX) || defined(__CYGWIN__)
#define UNIX
#endif

#include <stdio.h>
#include <stdlib.h>
#ifdef UNIX
#include <unistd.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <signal.h>
#include <sys/types.h>
#include <netdb.h>
#define WSAGetLastError() errno
#endif
#ifdef _WIN32

#include <windows.h>
#include <winbase.h>
#include <winsock.h>
#include <sys/timeb.h>
#include <signal.h>
#include <process.h>
#define THR_HANDLE HANDLE
#define MSG_NOSIGNAL 0
typedef struct sockaddr_in sockaddr_in_type;

#endif
#include <string.h>
#include <errno.h>

#define MAX_BUFFER_LENGTH   1024*2+4
char recBuffer[MAX_BUFFER_LENGTH];
char sendBuffer[MAX_BUFFER_LENGTH];
SOCKET AcceptSocket=0;
SOCKET targetsock=0;
int targetPort;
char *server_ip_address=0;
char running=1;
char Debug=0;
char dumpbuffer=0;
char dumpstop=0;
char waitBreak=0;
char state=0;
char ack=0;
char *priv_writeln=0;
char *atl_stop=0;
char *atl_buffer=0;
char Zbp='1';
int rtrt_buffer_size=256;
FILE *log=0;
FILE *spt=0;

void handler (int foo)
{
  printf("Server shut down!! signal %d\n",foo);
  if(log) fclose(log);
  if(spt) fclose(spt);
  exit (0);
}

void nextCmd(char *p)
{
	switch(++state)
	{
	 case 1:
	 	sprintf(p,"reset");
	 	break;
	 case 2:
	 	sprintf(p,"Z%c,%s,0",Zbp,priv_writeln);
	 	break;
	 case 3:
	 	*p++='c';*p=0;
	 	waitBreak++;
	 	break;
	 case 4:
	    if(atl_stop)
	    {
			dumpstop++;
			sprintf(p,"m%s,4",atl_stop);
			break;
		}
	 case 5:
	 	dumpbuffer++;
	 	sprintf(p,"m%s,%x",atl_buffer,rtrt_buffer_size);
	 	state=2;
	 	break;
	 default: running=0;
	}
}

/* handle little and big endian
   $00000000#80 =0
   $01000000#81 =1
   $00000001#81 =1
   */
char getStop(char *recBuffer)
{
	int i=8;
	if(*recBuffer++!='$') return 0;
	dumpstop=0;
	while(i--)
	{
		if(*recBuffer++ !='0')
		{
			if(Debug) printf("<STOP>\n");
			return 1;
		}
	}
	return 0;
}

char printSPT(char *recBuffer)
{
	int i=MAX_BUFFER_LENGTH-1;
	char *p=recBuffer;
	char *b=p;
	if(*b++!='$') return 0;
	dumpbuffer=0;
	while(i--)
	{
		char h=(*b++)<<4;
		char v=(*b++);
		if(v>'9')v+=9;
		v=(v&0xF)|h;
		*p++=v;
		if(v==0)i=0;
	}
	if(spt) fprintf(spt,"%s",recBuffer);
	else printf("%s",recBuffer);
	if(strstr(recBuffer,"tdp end")) return 1;
	return 0;
}

DWORD WINAPI
ThreadSocketClient(LPVOID lpParameter)
{
	int ret;
	do {
			ret = recv (targetsock, recBuffer, MAX_BUFFER_LENGTH,0);
			recBuffer[ret]=0;
			if(recBuffer[0]=='+')
			{
				ack=2;
				if(Debug) printf("<%d<%s\n",ret,recBuffer);
			}
			else if(recBuffer[0]=='-')
			{
				ack=2;
				printf("<%s\n",recBuffer);
				if(log) fprintf(log,"<%d<%s\n",ret,recBuffer);
			}
			else
			{
				ack=3;
				send (targetsock, "+", 1,MSG_NOSIGNAL);
				if(log) fprintf(log,"<%d<%s\n",ret,recBuffer);
				if(Debug>1) printf("<%s\n",recBuffer);
				if(dumpstop) {running=!getStop(recBuffer);} else
				if(dumpbuffer){ running=!printSPT(recBuffer);} else //destroy recBuffer
				if(waitBreak) { if(Debug) printf("priv_writeln hit\n");}
				ack=0;
			}
	} while(ret>0 && running);
	running=0;
	return 0;
}

void manageSocketClient()
{
 struct sockaddr_in local_mbx;
 struct hostent *hptr;
 unsigned int addr=0;
 int ret=0;
 THR_HANDLE myThread;
 DWORD lpThreadId;
 char hostname[256];
 memset ((void *) &local_mbx, 0, sizeof(struct sockaddr_in));
//=========================
 if(server_ip_address)
	 hptr = gethostbyname (server_ip_address);
 else
 {
   /* server is located on the same machine */
   ret = gethostname (hostname, 255);
   if (ret<0) {
			printf("#target gethostname failed %d\n",WSAGetLastError());
			return;
   }
   server_ip_address=hostname;
   // hptr = gethostbyname (hostname);
   hptr = gethostbyname ("127.0.0.1");
 }
 if (hptr == NULL){
 		printf("#target gethostbyname failed %d\n",WSAGetLastError());
 		return;
 }

 memcpy ((void *) &local_mbx.sin_addr, hptr->h_addr, hptr->h_length);
 local_mbx.sin_family = hptr->h_addrtype;
 local_mbx.sin_port = (unsigned short)(htons(targetPort));

 /* Create a new socket */
 targetsock = socket (AF_INET, SOCK_STREAM, 0);
 if (targetsock<0) {
		printf("#target socket failed%d\n",WSAGetLastError());
		return;
 }
 if (targetsock==0) {
		printf("#target socket =0 !!!!!\n");
		return;
 }
 /* Connect it to the Server port */
 ret = connect(targetsock, (struct sockaddr *)&local_mbx, sizeof(struct sockaddr_in));
 if (ret<0) {
		printf("#target connect port %d failed %d\n",targetPort,WSAGetLastError());
		return;
 }

#ifdef _WIN32
 myThread = CreateThread(
			NULL,  // pointer to security attributes
			0,                         // initial thread stack size
			(LPTHREAD_START_ROUTINE) ThreadSocketClient,		     // pointer to thread function
			NULL,                        // argument for new thread
			0,                     // creation flags
			&lpThreadId                         // pointer to receive thread ID
			);
#else //_WIN32
			 lpThreadId = pthread_create(&myThread
					,NULL /* attibutes */
				,(LPTHREAD_START_ROUTINE) ThreadSocketClient /* pointer to thread function */
				,(void *)NULL     /* argument for new thread */
					);

#endif //_WIN32
 sendBuffer[0]='$';
	do {
		char *p=&sendBuffer[1];
		unsigned char sum=0;
		ret=0;
		//fgets (p, MAX_BUFFER_LENGTH-1,stdin);
		nextCmd(p);
		p=&sendBuffer[1];
		while(*p && *p!=0xa && ret<MAX_BUFFER_LENGTH)
		{
			ret++;
			sum+=*p++;
		}
		ret++;
		sendBuffer[ret++]='#';
		sendBuffer[ret++]=((sum>>4)  > 9)?(sum >>4)+'A'-10:(sum >>4)+'0';
		sendBuffer[ret++]=((sum&0xF) > 9)?(sum&0xF)+'A'-10:(sum&0xF)+'0';
		sendBuffer[ret]=0;

		if(log) fprintf(log,">%d>%s\n",ret,sendBuffer);
		if(Debug>1) printf(">%d>%s\n",ret,sendBuffer);
		if(targetsock)
		{
			ack=1;
			send (targetsock, sendBuffer, ret,MSG_NOSIGNAL);
			sum=100;
			while(ack && sum--)
			{
				Sleep(100);
			}
			if(ack)
			{
				if(log) fprintf(log,">?ack=%d>\n",ack);
				if(Debug>1) printf(">?ack=%d>\n",ack);
			}
		}
	} while(ret>0 && running);
  running=0;
  closesocket(targetsock);
  targetsock=0;
  if(log) fclose(log);
  if(spt) fclose(spt);
}



int main (int argc, char * argv[])
{
	int i;
	targetPort=2331;
	for(i=1;i<argc;i++)
	{
		if(!strcmp("-d",argv[i]))
		{
			Debug=1;
		}
		else if(!strncmp("-d",argv[i],2))
		{
			Debug=argv[i][2]-'0';
		}
		else if(!strcmp("-target",argv[i]))
		{
			targetPort=atoi(argv[++i]);
		}
		else if(!strcmp("-rtrt_buffer_size",argv[i]))
		{
			rtrt_buffer_size=atoi(argv[++i]);
		}
		else if(!strcmp("-ip",argv[i]))
		{
			server_ip_address=(argv[++i]);
		}
		else if(!strcmp("-atl_buffer",argv[i]))
		{
			atl_buffer=(argv[++i]);
		}
		else if(!strcmp("-atl_stop",argv[i]))
		{
			atl_stop=(argv[++i]);
		}
		else if(!strcmp("-priv_writeln",argv[i]))
		{
			priv_writeln=(argv[++i]);
		}
		else if(!strcmp("-break_type",argv[i]))
		{
			Zbp=(argv[++i][0]);
		}
		else if(!strcmp("-log",argv[i]))
		{
			log=fopen(argv[++i],"a");
		}
		else if(!strcmp("-out",argv[i]))
		{
			spt=fopen(argv[++i],"w");
		}
	}
#ifdef _WIN32
	  signal (SIGINT,handler);
	  signal (SIGTERM, handler);
	  signal (SIGABRT, handler);
	  signal (SIGBREAK, handler);

	  signal (SIGILL, handler);
	  signal (SIGFPE, handler);
	//  signal (SIGSEGV, handler);
#else
	  signal (SIGINT, handler); // kill -2
	  signal (SIGQUIT, handler);
	  signal (SIGPIPE, handler);
	  signal (SIGHUP, handler);
	  signal (SIGILL, handler);
	  signal (SIGABRT, handler);
	//  signal (SIGSEGV, handler);
	  signal (SIGALRM, handler);
	  signal (SIGTERM, handler);
//	  signal (SIGCHLD, handler);
//	  signal (SIGSTOP, handler);
	  signal (SIGTSTP, handler);
	  signal (SIGTTOU, handler);
	//  signal (SIGBUS , handler);
	  signal (SIGXCPU, handler);

#endif
	if(running)
	{
		#ifdef _WIN32
		  WSADATA   wsaData;

		  if (WSAStartup(MAKEWORD(2,2), &wsaData) != NO_ERROR) {
			printf("Error at WSAStartup()\n");
			return 1;
		  }
		#endif
		if(priv_writeln && atl_buffer && rtrt_buffer_size <(MAX_BUFFER_LENGTH/2-2))
		{
			manageSocketClient();
		}
		else
		{
			printf("GDBserverClient v1.0\nusage: -priv_writeln <addr> -atl_buffer <addr> [-rtrt_buffer_size <size>] [-break_type <0-9>] [-atl_stop <addr>] [--out <spt>] [-log <logFile>] [-ip <ipV4>] [-target <port>] [-d[2]]\n where <addr> must be in hex: FFFF1345\n <spt> is the result spt file\n -d[n] provides debug info at level n\n default values for <size> is 256, break_type is 1,\n <spt> is stdout, <ipV4> is 127.0.0.1 and <port> is 2331\n");
		}
	}
}